diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/internet/test/ipv6-raw-test.cc ns-3.46/src/internet/test/ipv6-raw-test.cc
--- ns-3.45/src/internet/test/ipv6-raw-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/internet/test/ipv6-raw-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -5,11 +5,12 @@
  *
  * Author: Hajime Tazaki <tazaki@sfc.wide.ad.jp>
  */
-/**
+/*
  * This is the test code for ipv6-raw-socket-impl.cc.
  */
 
 #include "ns3/boolean.h"
+#include "ns3/error-model.h"
 #include "ns3/icmpv6-l4-protocol.h"
 #include "ns3/inet6-socket-address.h"
 #include "ns3/internet-stack-helper.h"
@@ -21,6 +22,7 @@
 #include "ns3/log.h"
 #include "ns3/node-container.h"
 #include "ns3/node.h"
+#include "ns3/pointer.h"
 #include "ns3/simple-channel.h"
 #include "ns3/simple-net-device-helper.h"
 #include "ns3/simple-net-device.h"
@@ -43,6 +45,198 @@
 
 using namespace ns3;
 
+NS_LOG_COMPONENT_DEFINE("ipv6-raw-fragmentation-test");
+
+/**
+ * @ingroup internet-test
+ *
+ * @brief IPv6 Raw Socket Fragmentation Test
+ * Configuration : Two sockets. 1 sender, 1 receiver
+ *                 Sender socket sends packets in two epochs.
+ *                 In the first epoch, it sends payload of sizes {500, 1000, 5000, 10000,
+ *                 20000, 40000, 60000}.
+ *                 In the second epoch, it sends payload of sizes {5000, 10000, 20000,
+ *                 40000, 60000}. These are payloads of size greater than the MTU of
+ *                 the link.
+ *                 In the first epoch, there is no loss model.
+ *                 In the second epoch, the second fragment of the packet sent is dropped.
+ *
+ * Expected behaviour: In the first epoch: Receiver should receive only 1 packet and the size of
+ *                     the payload received should be equal to the size of the payload sent.
+ *                     No packets should have been dropped.
+ *                     In the second epoch: Receiver should not receive any packet. Only 1 packet
+ *                     should have been dropped at the physical layer.
+ */
+class Ipv6RawFragmentationTest : public TestCase
+{
+  public:
+    Ipv6RawFragmentationTest();
+    void DoRun() override;
+
+  private:
+    /**
+     * @brief         Send a packet
+     * @param socket  The sending socket
+     * @param dst     Destination IPv6 address.
+     * @param size    Size (bytes) of the payload to send.
+     */
+    void SendPacket(Ptr<Socket> socket, Ipv6Address dst, uint32_t size);
+
+    /**
+     * @brief Receive a packet
+     * @param socket Socket that received a packet
+     */
+    void RxCallback(Ptr<Socket> socket);
+
+    /**
+     * @brief Packet dropped callback at Phy Rx.
+     * @param p Dropped packet.
+     */
+    void PhyRxDropCallback(Ptr<const Packet> p);
+
+    uint32_t m_rxCount{0};          //!< Total count of packets received.
+    uint32_t m_rxPayloadSize{0};    //!< Size of the last packet received.
+    uint32_t m_droppedFragments{0}; //!< Number of dropped packets
+};
+
+Ipv6RawFragmentationTest::Ipv6RawFragmentationTest()
+    : TestCase("ipv6-raw-fragmentation-test")
+{
+}
+
+void
+Ipv6RawFragmentationTest::RxCallback(Ptr<Socket> socket)
+{
+    Ptr<Packet> p = socket->Recv(std::numeric_limits<uint32_t>::max(), 0);
+
+    Ipv6Header hdr;
+    if (p->PeekHeader(hdr))
+    {
+        p->RemoveHeader(hdr);
+    }
+
+    m_rxPayloadSize = p->GetSize();
+    m_rxCount++;
+    NS_LOG_DEBUG("Receiver got " << m_rxPayloadSize << " bytes");
+}
+
+void
+Ipv6RawFragmentationTest::SendPacket(Ptr<Socket> sock, Ipv6Address dst, uint32_t size)
+{
+    Ptr<Packet> p = Create<Packet>(size);
+    sock->SendTo(p, 0, Inet6SocketAddress(dst, 0));
+    NS_LOG_DEBUG("Sender sent " << p->GetSize() << " bytes to " << dst);
+}
+
+void
+Ipv6RawFragmentationTest::PhyRxDropCallback(Ptr<const Packet> /*p*/)
+{
+    ++m_droppedFragments;
+}
+
+void
+Ipv6RawFragmentationTest::DoRun()
+{
+    Ptr<Node> rxNode = CreateObject<Node>();
+    Ptr<Node> txNode = CreateObject<Node>();
+
+    SimpleNetDeviceHelper helper;
+    helper.SetNetDevicePointToPointMode(true);
+
+    Ptr<SimpleNetDevice> rxDev = DynamicCast<SimpleNetDevice>(helper.Install(rxNode).Get(0));
+    Ptr<SimpleNetDevice> txDev = DynamicCast<SimpleNetDevice>(helper.Install(txNode).Get(0));
+
+    txDev->SetMtu(1280); // Minimum MTU allowed for IPv6
+
+    rxDev->TraceConnectWithoutContext(
+        "PhyRxDrop",
+        MakeCallback(&Ipv6RawFragmentationTest::PhyRxDropCallback, this));
+
+    Ptr<SimpleChannel> ch = CreateObject<SimpleChannel>();
+    rxDev->SetChannel(ch);
+    txDev->SetChannel(ch);
+
+    InternetStackHelper stack;
+    stack.SetIpv4StackInstall(false);
+    stack.Install(NodeContainer(rxNode, txNode));
+
+    rxNode->GetObject<Icmpv6L4Protocol>()->SetAttribute("DAD", BooleanValue(false));
+    txNode->GetObject<Icmpv6L4Protocol>()->SetAttribute("DAD", BooleanValue(false));
+
+    Ptr<Ipv6> ipv6Rx = rxNode->GetObject<Ipv6>();
+    Ptr<Ipv6> ipv6Tx = txNode->GetObject<Ipv6>();
+
+    uint32_t ifRx = ipv6Rx->AddInterface(rxDev);
+    ipv6Rx->AddAddress(ifRx, Ipv6InterfaceAddress("2001:db8::1", Ipv6Prefix(64)));
+    ipv6Rx->SetUp(ifRx);
+
+    uint32_t ifTx = ipv6Tx->AddInterface(txDev);
+    ipv6Tx->AddAddress(ifTx, Ipv6InterfaceAddress("2001:db8::2", Ipv6Prefix(64)));
+    ipv6Tx->SetUp(ifTx);
+
+    const uint8_t proto = Ipv6Header::IPV6_ICMPV6;
+
+    Ptr<Socket> rxSock = rxNode->GetObject<Ipv6RawSocketFactory>()->CreateSocket();
+    rxSock->SetAttribute("Protocol", UintegerValue(proto));
+    rxSock->Bind(Inet6SocketAddress(Ipv6Address::GetAny(), 0));
+    rxSock->SetRecvCallback(MakeCallback(&Ipv6RawFragmentationTest::RxCallback, this));
+
+    Ptr<Socket> txSock = txNode->GetObject<Ipv6RawSocketFactory>()->CreateSocket();
+    txSock->SetAttribute("Protocol", UintegerValue(proto));
+
+    std::vector<uint32_t> payloadSizes = {500, 1000, 5000, 10000, 20000, 40000, 60000};
+
+    for (auto sentPayloadSize : payloadSizes)
+    {
+        m_rxCount = 0;
+        m_rxPayloadSize = 0;
+
+        Simulator::Schedule(Seconds(0.0),
+                            &Ipv6RawFragmentationTest::SendPacket,
+                            this,
+                            txSock,
+                            Ipv6Address("2001:db8::1"),
+                            sentPayloadSize);
+        Simulator::Stop(Seconds(1.0));
+        Simulator::Run();
+
+        NS_TEST_EXPECT_MSG_EQ(m_rxPayloadSize,
+                              sentPayloadSize,
+                              "Reassembled packet size should be the same as the packet size sent");
+
+        NS_TEST_EXPECT_MSG_EQ(m_rxCount, 1, "Only 1 packet should have been received");
+
+        NS_TEST_EXPECT_MSG_EQ(m_droppedFragments, 0, "No packets should have been dropped");
+    }
+
+    std::vector<uint32_t> fragmentablePayloadSizes = {5000, 10000, 20000, 40000, 60000};
+
+    for (auto sentPayloadSize : fragmentablePayloadSizes)
+    {
+        m_rxCount = 0;
+        m_droppedFragments = 0;
+
+        Ptr<ReceiveListErrorModel> errModel = CreateObject<ReceiveListErrorModel>();
+        errModel->SetList({1});
+
+        rxDev->SetAttribute("ReceiveErrorModel", PointerValue(errModel));
+
+        Simulator::Schedule(Seconds(0.0),
+                            &Ipv6RawFragmentationTest::SendPacket,
+                            this,
+                            txSock,
+                            Ipv6Address("2001:db8::1"),
+                            sentPayloadSize);
+        Simulator::Stop(Seconds(1.0));
+        Simulator::Run();
+
+        NS_TEST_EXPECT_MSG_EQ(m_rxCount, 0, "No packet should have been received");
+
+        NS_TEST_EXPECT_MSG_EQ(m_droppedFragments, 1, "Exactly 1 packet should have been dropped.");
+    }
+    Simulator::Destroy();
+}
+
 /**
  * @ingroup internet-test
  *
@@ -322,6 +516,7 @@
         : TestSuite("ipv6-raw", Type::UNIT)
     {
         AddTestCase(new Ipv6RawSocketImplTest, TestCase::Duration::QUICK);
+        AddTestCase(new Ipv6RawFragmentationTest, TestCase::Duration::QUICK);
     }
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/internet/test/tcp-advertised-window-test.cc ns-3.46/src/internet/test/tcp-advertised-window-test.cc
--- ns-3.45/src/internet/test/tcp-advertised-window-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/internet/test/tcp-advertised-window-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -52,7 +52,7 @@
         : TcpSocketMsgBase(other)
     {
         m_segmentSize = other.m_segmentSize;
-        m_inwalidAwndCb = other.m_inwalidAwndCb;
+        m_invalidAwndCb = other.m_invalidAwndCb;
     }
 
     /**
@@ -78,7 +78,7 @@
 
   private:
     uint16_t OldAdvertisedWindowSize(bool scale = true) const;
-    InvalidAwndCallback m_inwalidAwndCb; //!< Callback
+    InvalidAwndCallback m_invalidAwndCb; //!< Callback
 
     /**
      * @brief Test meta-information: size of the segments that are received.
@@ -93,7 +93,7 @@
 TcpSocketAdvertisedWindowProxy::SetInvalidAwndCb(InvalidAwndCallback cb)
 {
     NS_ASSERT(!cb.IsNull());
-    m_inwalidAwndCb = cb;
+    m_invalidAwndCb = cb;
 }
 
 TypeId
@@ -148,9 +148,9 @@
 
             if (static_cast<uint16_t>(newAwndKnownDifference) != oldAwnd)
             {
-                if (!m_inwalidAwndCb.IsNull())
+                if (!m_invalidAwndCb.IsNull())
                 {
-                    m_inwalidAwndCb(oldAwnd, newAwnd);
+                    m_invalidAwndCb(oldAwnd, newAwnd);
                 }
             }
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/internet/test/tcp-pacing-test.cc ns-3.46/src/internet/test/tcp-pacing-test.cc
--- ns-3.45/src/internet/test/tcp-pacing-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/internet/test/tcp-pacing-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -242,7 +242,7 @@
 TcpPacingTest::UpdateExpectedInterval()
 {
     double_t factor;
-    Time rtt = 2 * GetPropagationDelay();
+
     if (m_curCwnd < m_ssThresh / 2)
     {
         factor = static_cast<double>(m_pacingSsRatio) / 100;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/internet/test/tcp-rate-ops-test.cc ns-3.46/src/internet/test/tcp-rate-ops-test.cc
--- ns-3.45/src/internet/test/tcp-rate-ops-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/internet/test/tcp-rate-ops-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -569,8 +569,7 @@
                             MakeCallback(&TcpRateOps::SkbDelivered, m_rateOps));
     }
     m_expectedAckedSacked = 5 * m_segmentSize;
-    TcpRateOps::TcpRateSample rateSample =
-        m_rateOps->GenerateSample(5 * m_segmentSize, 0, false, priorInFlight, Seconds(0));
+    m_rateOps->GenerateSample(5 * m_segmentSize, 0, false, priorInFlight, Seconds(0));
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/internet-apps/test/dhcp6-test.cc ns-3.46/src/internet-apps/test/dhcp6-test.cc
--- ns-3.45/src/internet-apps/test/dhcp6-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/internet-apps/test/dhcp6-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -29,8 +29,6 @@
 #include "ns3/ssid.h"
 #include "ns3/test.h"
 #include "ns3/trace-helper.h"
-#include "ns3/wifi-helper.h"
-#include "ns3/yans-wifi-helper.h"
 
 using namespace ns3;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/internet-apps/test/ping-test.cc ns-3.46/src/internet-apps/test/ping-test.cc
--- ns-3.45/src/internet-apps/test/ping-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/internet-apps/test/ping-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -605,7 +605,7 @@
     testcase2v4->SetSimulatorStopTime(Seconds(5));
     testcase2v4->CheckReportTransmitted(1);
     testcase2v4->CheckReportReceived(0);
-    testcase1v4->SetDestinationAddress(Ipv4Address("10.0.0.2"));
+    testcase2v4->SetDestinationAddress(Ipv4Address("10.0.0.2"));
     AddTestCase(testcase2v4, TestCase::Duration::QUICK);
 
     auto testcase2v6 = new PingTestCase(
@@ -697,8 +697,8 @@
     // 5. Test for behavior of pinging an unreachable host when the
     //    network does not send an ICMP unreachable message.
     // Unlimited pings, StopApplication () with no packet in flight
-    // Configuration:  Ping::Count = 0,  Ping start time = 1s
-    //                 Ping stop time = 5.5s.  Ping to unknown destination.
+    // Configuration:  Ping::Count = 5,  Ping start time = 1s
+    //                 Ping stop time = 6.5s.  Ping to unknown destination.
     // Expected behavior:  By default, the timeout value is 1 second.  Ping
     //                     sends first packet at time 1 second, and does not
     //                     receive a response.  At the timeout (simulation time
@@ -900,30 +900,39 @@
     testcase9v6->CheckReportTime(MicroSeconds(3040000));
     AddTestCase(testcase9v6, TestCase::Duration::QUICK);
 
-#ifdef NOTYET
-    //
-    // 10. Test for behavior of pinging on a link that causes IPv4 fragmentation
-    // Configuration:  Ping::Count = 1,  Ping start time = 1s
-    //                 Ping stop time = 2.5s.  Ping to Node 1
-    //                 Ping size set to 2000 bytes.
-    // Expected behavior:  At shortly after time 1 seconds, Ping should
-    //                     successfully exit by recording the successful
-    //                     exchange of one echo request and reply.
-    // How validated:  PingReport trace is checked for number of packets
-    //                 transmitted (5) and  received (0).
-    //                 PingReport time is checked for an explicit time
-    //                 (1.020028s) corresponding to 2000 bytes
-    //                 The packet loss rate should be checked to be 100 percent
-    PingTestCase* testcase10v4 = new PingTestCase("10. Test for IPv4 fragmentation", USEIPV6_FALSE);
+    // 10. Test for behavior of pinging with a big size that causes fragmentation
+    //    Configuration:  Ping::Count = 5,  Ping::Interval = 1s, Ping start
+    //                    time = 1s, Ping stop time = 6.5s,
+    //                    Payload size = 60000B
+    //    Expected behavior:  Pings are sent at times 1, 2, 3, 4, 5 sec.  The
+    //                        number sent equals number received, which equals 5.
+    //    How validated:  PingReport trace is checked for number of packets
+    //                    transmitted and received (5), and number of drops (0).
+    auto testcase10v4 = new PingTestCase("10. 5 pings, heavy payload, no losses, "
+                                         "StopApplication () with no packets in flight IPv4",
+                                         USEIPV6_FALSE);
     testcase10v4->SetStartTime(Seconds(1));
-    testcase10v4->SetStopTime(Seconds(2.5));
-    testcase10v4->SetCount(1);
-    testcase10v4->SetSize(2000);
-    testcase10v4->CheckReportTransmitted(1);
-    testcase10v4->CheckReportReceived(1);
-    testcase10v4->CheckReportTime(MicroSeconds(1020028));
+    testcase10v4->SetStopTime(Seconds(6.5));
+    testcase10v4->SetCount(5);
+    testcase10v4->SetSize(60000);
+    testcase10v4->CheckReportTransmitted(5);
+    testcase10v4->CheckReportReceived(5);
+    testcase10v4->CheckTraceTx(5);
+    testcase10v4->SetDestinationAddress(Ipv4Address("10.0.0.2"));
     AddTestCase(testcase10v4, TestCase::Duration::QUICK);
-#endif
+
+    auto testcase10v6 = new PingTestCase("10. 5 pings, heavy payload,  no losses, "
+                                         "StopApplication () with no packets in flight IPv6",
+                                         USEIPV6_TRUE);
+    testcase10v6->SetStartTime(Seconds(1));
+    testcase10v6->SetStopTime(Seconds(6.5));
+    testcase10v6->SetCount(5);
+    testcase10v6->SetSize(60000);
+    testcase10v6->CheckReportTransmitted(5);
+    testcase10v6->CheckReportReceived(5);
+    testcase10v6->CheckTraceTx(5);
+    testcase10v6->SetDestinationAddress(Ipv6Address("2001:1::200:ff:fe00:2"));
+    AddTestCase(testcase10v6, TestCase::Duration::QUICK);
 }
 
 static PingTestSuite pingTestSuite; //!< Static variable for test initialization
